/*********************
 Sudoko Solver
 Nalini Vasudevan
*********************/

/*xor operation on two bits a & e:  a'e + e'a = (a' + e')(a + e)*/
/*xor operation on 4 bits abcd & efgh = (a' + e')(a + e) + (b' + f')(b + f) + ..
					=                                        */  

#include<stdio.h>
#include <stdlib.h>


#define MAX 9
#define BITS 4 // No. of bits required to represent each number 

int clauses = 0;

ors_of_xor (int a [], int b [], int num)
{
if (num == -1)
{
	int i;
	for (i = 0; i < BITS ; i ++)
		printf("%d ", a[i]); 
	for (i = 0; i < BITS ; i ++)
		printf("%d ", b[i]); 
	printf("%d\n", 0);
	clauses ++;
	return;

}
ors_of_xor (a, b, num - 1);
a[num] = - a[num]; b[num] = -b[num];
ors_of_xor (a, b, num - 1);
a[num] = - a[num]; b[num] = -b[num];
}

generate_validity (start1, start2)
{
  int i;
  int a[BITS];
  int b[BITS];
  for (i=0; i< BITS; i++)
	{
	a[i] = start1 + i + 1;
	b[i] = start2 + i + 1;
	}
ors_of_xor (a, b, BITS - 1);

}


int generic_solver ()
{
int i, j, k, l, row, col, subgrid;
for (row = 0; row < MAX ; row ++)
	for (i = 0; i < MAX; i++)
		for (j = i + 1; j < MAX; j++)
			generate_validity ((row*MAX + i)*4 , (row*MAX + j)*4);
	  
for (col = 0; col < MAX ;col ++)
	for (i = 0; i < MAX; i++)
		for (j = i + 1; j < MAX; j++)
			generate_validity ((i*MAX + col)*4 , (j*MAX + col)*4);

for (subgrid = 0; subgrid < MAX ; subgrid ++)
{
	int start_row = (subgrid/3)*3;
	int start_col = (subgrid%3)*3;
	
	for (i = 0; i < 3; i++)
		for (j = 0; j < 3; j++)
			for (k = 0; k < 3; k++)
				for (l = 0; l < 3; l++)
					if ((i !=  k) || (j != l))
						generate_validity (((start_row + i)*MAX + start_col + j)*4 , ((start_row + k)*MAX + start_col +l)*4);
}

}


int part_of_cnf (int i, int j, int value)
{
	int k = 0;
	int literal = (i * MAX + j) * 4 + 1;
	for (k = 0; k < BITS; k++)
		{
		if (value & (1 << (BITS - 1 -k)))
			printf("%d %d\n", literal, 0);
		else
			printf("%d %d\n", -literal, 0);
		clauses ++;
		literal = literal + 1;
	
		}
}


int use_file_contents(char * filename)
{
	FILE * fp = fopen (filename, "r");
	if (fp == NULL)
		printf("Error reading file\n");
	char ch;
	int i, j;
	for (i = 0; i < 9; i++)
	{
		for (j = 0; j < 9; j++)
		{
			ch =  fgetc (fp);
			if (ch >= '1' && ch <= '9')
				part_of_cnf( i, j, ch-'1');
		}
		ch = fgetc(fp); // to read \n
	}
}


/* a' + ab'c'd'*/
/*(a'+ b')  (a' + c') (a' + d')*/
int remove_unused_bits ()
{
	int i, j;
	int l1, l2, l3, l4;
	for (i = 0; i < 9 ; i++)
		for (j = 0; j < 9 ; j++)
		{
		
			l1 = (i*MAX + j)*4 + 1;
			l2 = l1 + 1;
			l3 = l1 + 2;
			l4 = l1 + 3;
			printf("%d %d %d\n", -l1, -l2, 0);
			printf("%d %d %d\n", -l1, -l3, 0);
			printf("%d %d %d\n", -l1, -l4, 0);
			clauses = clauses + 3;
		}

}

	

int main(int argc, char** argv)
{
	if (argc != 2)
		{
		printf ("./sudoko filename\n");
		return;
		}
	use_file_contents (argv[1]);
	generic_solver();
	remove_unused_bits();
	printf ("p cnf %d %d\n", 324, clauses);
}
